<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>virtual_db Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>virtual_db Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Pistolea</span></h3><code class="email">&lt;<a class="email" href="mailto:razvy000@yahoo.com">razvy000@yahoo.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Pistolea</span></h3><code class="email">&lt;<a class="email" href="mailto:razvy000@yahoo.com">razvy000@yahoo.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5917 $</td><td align="left">$Date: 2009-07-29 18:12:14 +0200 (Wed, 29 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277539">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id267979">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id271308">1.1.1.  The idea</a></span></dt><dt><span class="section"><a href="#id284072">1.1.2.  Modes </a></span></dt><dt><span class="section"><a href="#id249293">1.1.3.  Failures</a></span></dt><dt><span class="section"><a href="#id249600">1.1.4. The timer process</a></span></dt></dl></dd><dt><span class="section"><a href="#id249613">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249619">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248379">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248407">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248413">1.3.1. 
                <code class="varname">db_urls</code> (str)
            </a></span></dt><dt><span class="section"><a href="#id248447">1.3.2. 
                <code class="varname">db_probe_time</code> (integer)
            </a></span></dt><dt><span class="section"><a href="#id293426">1.3.3. 
                <code class="varname">db_max_consec_retrys</code> (integer)
            </a></span></dt></dl></dd><dt><span class="section"><a href="#id293465">1.4. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293470">1.4.1. 
                <code class="function">db_get</code>
            </a></span></dt><dt><span class="section"><a href="#id293514">1.4.2. 
                <code class="function">db_set</code>
            </a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248426">Set
                    <code class="varname">db_urls</code> parameter
                </a></dt><dt>1.2. <a href="#id293411">Set
                    <code class="varname">db_probe_time</code> parameter
                </a></dt><dt>1.3. <a href="#id293447">Set
                    <code class="varname">db_max_consec_retrys</code> parameter
                </a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277539"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id267979"></a>1.1. Overview</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id271308"></a>1.1.1.  The idea</h3></div></div></div><p>
                A virtual db will expose the same front db api however, it will backed by many real db.
                This means that a virtual db url translates to many real db urls.
                This virtual layer also enables us to use the real dbs in multiple ways such as: parallel, failover(hotswap), round-robin.

                Therefore: 
                    each virtual db url with associated real dbs and
                    a way to use(mode) it's real dbs must be specified.
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284072"></a>1.1.2.  Modes </h3></div></div></div><p>
                    The implemented modes are:
                </p><div class="itemizedlist"><ul type="disc"><li>
                            FAILOVER
                        <p>
                                Use the first url; if it fails, use the next one, redo operation.
                        </p></li><li>
                            PARALLEL
                        <p>
                                Use all the urls in the virtual db url.
                                Fails if all the urls fail.
                        </p></li><li>
                            ROUND (round-robin)
                        <p>
                                Use the next url each time; if it fails, use the next one, redo operation.
                        </p></li></ul></div><p>
            </p><p>
                    There are conceptual limitations to the above modes with respect to the operation.
                    For example in parallel mode it is ok to insert into multiple dbs the same value but it
                    is bad to query multiple dbs into the same result.
                    This implementation threats such operation as it would be in failover mode.
                    </p><p>
                </p><pre class="programlisting">
  Conceptual allowed(1) and not allowed(0) operations
                          parallel    round
    dbb-&gt;use_table
    dbb-&gt;init
    dbb-&gt;close

    dbb-&gt;query              0           1
    dbb-&gt;fetch_result       0           0
    dbb-&gt;raw_query          0           1
    dbb-&gt;free_result        0           0
    dbb-&gt;insert             1           1
    dbb-&gt;delete             1           0
    dbb-&gt;update             1           0
    dbb-&gt;replace            1           0
    dbb-&gt;last_inserted_id   0           0
    dbb-&gt;insert_update      1           1
                </pre><p>
                </p><p>
                </p><p>
                    Note 1: The capabilities returned are the minimum common denominator of all the dbs in the set.
                    The capabilities are reduced even more based on the mode of the set (PARALLEL, ROUND).
                </p><p>
                </p><p>
                    Note 2: The capabilities will not be reduced for PARALLEL mode but conceptual not allowed operations
                    will be done on a single db.
                    Ex: query will only query one db.
                </p><p>
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249293"></a>1.1.3.  Failures</h3></div></div></div><p>
                </p><pre class="programlisting">
    When an operation from a process on a real db fails:
        it is marked (global and local CAN flag down)
        its connection closed

    Later a timer process (probe):
    foreach virtual db url
        foreach real db_url
            if global CAN down
                try to connect
            if ok
                global CAN up
                close connection

    Later each process:
        if local CAN down and global CAN up
            if db_max_consec_retrys *
                try to connect
        if ok
            local CAN up

                </pre><p>
            </p><p>
                Note *: there could be inconsistencies between the probe and each process so a retry limit is in order.
                It is reset and ignored by an MI command.
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249600"></a>1.1.4. The timer process</h3></div></div></div><p>
                The timer process(probe) is a process that tries to reconnect to failed dbs from time to time.
                It is a separate process so that when it blocks (for a timeout on the connection) it doesnt matter.
            </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249613"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249619"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
                </p><div class="itemizedlist"><ul type="disc"><li><p>
				
                            <span class="emphasis"><em>At least one real db module</em></span>.
                        </p></li></ul></div><p>
            </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248379"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
                </p><div class="itemizedlist"><ul type="disc"><li><p>
				
                            <span class="emphasis"><em>None</em></span>.
                        </p></li></ul></div><p>
            </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248407"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248413"></a>1.3.1. 
                <code class="varname">db_urls</code> (str)
            </h3></div></div></div><p>
		Multiple value parameter used for virtual db urls declaration.
            </p><div class="example"><a name="id248426"></a><p class="title"><b>Example 1.1. Set
                    <code class="varname">db_urls</code> parameter
                </b></p><div class="example-contents"><pre class="programlisting">
...

modparam("group","db_url","virtual://set1")
modparam("presence|presence_xml", "db_url","virtual://set2")

modparam("db_virtual", "db_urls", "define set1 PARALLEL")
modparam("db_virtual", "db_urls", "mysql://opensips:opensipsrw@localhost/testa")
modparam("db_virtual", "db_urls", "postgres://opensips:opensipsrw@localhost/opensips")

modparam("db_virtual", "db_urls", "define set2 FAILOVER")
modparam("db_virtual", "db_urls", "mysql://opensips:opensipsrw@localhost/testa")
...
                </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248447"></a>1.3.2. 
                <code class="varname">db_probe_time</code> (integer)
            </h3></div></div></div><p>
        Time interval after which a registered timer process attempts to check
        failed(as reported by other processes) connections to real dbs. The probe will connect and
        disconnect to the failed real db and announce others.
            </p><p>
                <span class="emphasis"><em>
			Default value is 10 (10 sec).
                </em></span>
            </p><div class="example"><a name="id293411"></a><p class="title"><b>Example 1.2. Set
                    <code class="varname">db_probe_time</code> parameter
                </b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_virtual", "db_probe_time", 20)
...
                </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293426"></a>1.3.3. 
                <code class="varname">db_max_consec_retrys</code> (integer)
            </h3></div></div></div><p>
        After the timer process has reported that it can connect to the real db,
        other processes will try to reconnect to it. There are cases where although
        the probe could connect some might fail. This parameter represents the number
        of consecutive failed retries that a process will do before it gives up.
        This value is reset and suppressed by a MI function(db_set).
            </p><p>
                <span class="emphasis"><em>
			Default value is 10 (10 consecutive times).
                </em></span>
            </p><div class="example"><a name="id293447"></a><p class="title"><b>Example 1.3. Set
                    <code class="varname">db_max_consec_retrys</code> parameter
                </b></p><div class="example-contents"><pre class="programlisting">
...
modparam("db_virtual", "db_max_consec_retrys", 20)
...

                </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293465"></a>1.4. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293470"></a>1.4.1. 
                <code class="function">db_get</code>
            </h3></div></div></div><p>
		Return information about global state of the real dbs.
            </p><p>
		Name: 
                <span class="emphasis"><em>db_get</em></span>
            </p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li><p>None.
                    </p></li></ul></div><p>
		MI FIFO Command Format:
            </p><pre class="programlisting">
                db_get
                _empty_line_
            </pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293514"></a>1.4.2. 
                <code class="function">db_set</code>
            </h3></div></div></div><p>Sets the permissions for real dbs access per set per db.</p><p>Sets the reconnect reset flag.</p><p>
		Name:
                <span class="emphasis"><em>db_set</em></span>
            </p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li>set_index [int]</li><li>db_url_index [int]</li><li>may_use_db_flag [boolean]</li><li>ignore db_max_consec_retrys[boolean](optional)</li></ul></div><p>db_set 3 2 0 1 means: </p><div class="itemizedlist"><ul type="disc"><li> 3 - the fourth set (must exist)</li><li> 2 - the third url in the fourth set(must exist)</li><li> 0 - processes are not allowed to use that url</li><li> 1 - reset and suppress db_max_consec_retrys</li></ul></div><p>
		MI FIFO Command Format:
            </p><pre class="programlisting">
                db_set 3 2 0 1
                _empty_line_
            </pre></div></div></div></div></body></html>
