<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Options Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>Options Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Nils</span> <span class="surname">Ohlmeier</span></h3><div class="affiliation"><span class="orgname">FhG Fokus<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Nils</span> <span class="surname">Ohlmeier</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG Fokus</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2009-07-21 09:45:05 +0200 (Tue, 21 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277967">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id281466">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248002">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248008">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249271">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249296">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249302">1.3.1. <code class="varname">accept</code> (string)</a></span></dt><dt><span class="section"><a href="#id249628">1.3.2. <code class="varname">accept_encoding</code> (string)</a></span></dt><dt><span class="section"><a href="#id248400">1.3.3. <code class="varname">accept_language</code> (string)</a></span></dt><dt><span class="section"><a href="#id248441">1.3.4. <code class="varname">support</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293424">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293429">1.4.1. 
		<code class="function">options_reply()</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249607">Set <code class="varname">accept</code> parameter</a></dt><dt>1.2. <a href="#id248383">Set <code class="varname">accept_encoding</code> parameter</a></dt><dt>1.3. <a href="#id248424">Set <code class="varname">accept_language</code> parameter</a></dt><dt>1.4. <a href="#id293407">Set <code class="varname">support</code> parameter</a></dt><dt>1.5. <a href="#id293464"><code class="function">options_reply</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277967"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id281466"></a>1.1. Overview</h2></div></div></div><p>
		This module provides a function to answer OPTIONS requests which 
		are directed to the server itself. This means an OPTIONS request 
		which has the address of the server in the request URI, and no 
		username in the URI. The request will be answered with a 200 OK 
		which the capabilities of the server.
	</p><p>
		To answer OPTIONS request directed to your server is the easiest
		way for is-alive-tests on the SIP (application) layer from remote 
		(similar to	ICMP echo requests, also known as &#8220;<span class="quote">ping</span>&#8221;, 
		on the network layer).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248002"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248008"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>sl</em></span> -- Stateless replies.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249271"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249296"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249302"></a>1.3.1. <code class="varname">accept</code> (string)</h3></div></div></div><p>
			This parameter is the content of the Accept header field.
			Note: it is not clearly written in RFC3261 if a proxy should
			accept any content (the default &#8220;<span class="quote">*/*</span>&#8221;) because 
			it does not care about content. Or if it does not accept 
			any content, which is &#8220;<span class="quote"></span>&#8221;.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">*/*</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249607"></a><p class="title"><b>Example 1.1. Set <code class="varname">accept</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("options", "accept", "application/*")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249628"></a>1.3.2. <code class="varname">accept_encoding</code> (string)</h3></div></div></div><p>
			This parameter is the content of the Accept-Encoding header field.
			Please do not change the default value because OpenSIPS 
			does not support any encodings yet.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote"></span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248383"></a><p class="title"><b>Example 1.2. Set <code class="varname">accept_encoding</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("options", "accept_encoding", "gzip")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248400"></a>1.3.3. <code class="varname">accept_language</code> (string)</h3></div></div></div><p>
			This parameter is the content of the Accept-Language header field.
			You can set any language code which you prefer for error 
			descriptions from other devices, but presumably there are not
			much devices around which support other languages then the 
			default English.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">en</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248424"></a><p class="title"><b>Example 1.3. Set <code class="varname">accept_language</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("options", "accept_language", "de")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248441"></a>1.3.4. <code class="varname">support</code> (string)</h3></div></div></div><p>
			This parameter is the content of the Support header field.
			Please do not change the default value, because OpenSIPS currently 
			does not support any of the SIP extensions registered at the IANA.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote"></span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id293407"></a><p class="title"><b>Example 1.4. Set <code class="varname">support</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("options", "support", "100rel")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293424"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293429"></a>1.4.1. 
		<code class="function">options_reply()</code>
		</h3></div></div></div><p>
			This function checks if the request method is OPTIONS and
			if the request URI does not contain an username. If both
			is true the request will be answered stateless with 
			&#8220;<span class="quote">200 OK</span>&#8221; and the capabilities from the modules
			parameters.
		</p><p>
			It sends &#8220;<span class="quote">500 Server Internal Error</span>&#8221; for some errors
			and returns false if it is called for a wrong request.
		</p><p>
			The check for the request method and the missing username is
			optional because it is also done by the function itself. But
			you should not call this function outside the myself check
			because in this case the function could answer OPTIONS requests
			which are sent to you as outbound proxy but with an other
			destination then your proxy (this check is currently missing
			in the function).
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293464"></a><p class="title"><b>Example 1.5. <code class="function">options_reply</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (uri==myself) {
	if ((method==OPTIONS) &amp;&amp; (! uri=~"sip:.*[@]+.*")) {
		options_reply();
	}
}
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
