<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Statistics Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>Statistics Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2012-02-22 18:29:43 +0100 (Wed, 22 Feb 2012) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id281466">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id273420">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284080">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248001">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249303">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249265">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249270">1.3.1. <code class="varname">variable</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249604">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249609">1.4.1. 
		<code class="function">update_stat(variable,value)</code>
		</a></span></dt><dt><span class="section"><a href="#id248403">1.4.2. 
		<code class="function">reset_stat(variable)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id293409">1.5. Exported pseudo-variables</a></span></dt><dd><dl><dt><span class="section"><a href="#id293414">1.5.1. <code class="varname">$stat</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249585">variable example</a></dt><dt>1.2. <a href="#id248384"><code class="function">update_stat</code> usage</a></dt><dt>1.3. <a href="#id248437"><code class="function">reset_stat</code> usage</a></dt><dt>1.4. <a href="#id293426"><code class="varname">$stat</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id281466"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id273420"></a>1.1. Overview</h2></div></div></div><p>
		The <acronym class="acronym">Statistics</acronym> module is a wrapper over the internal
		statistics manager, allowing the script writer to dynamically define and
		use of statistic variables.
	</p><p>
		By bringing the statistics support into the script, it takes advantage
		of the script flexibility in defining logics, making possible 
		implementation of any kind of statistic scenario.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284080"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248001"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249303"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249265"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249270"></a>1.3.1. <code class="varname">variable</code> (string)</h3></div></div></div><p>
		Name of a new statistic variable. The name may be followed by additional
		flag which describe the variable behavior:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>no_reset</em></span> : variable cannot be reset.
			</p></li></ul></div><div class="example"><a name="id249585"></a><p class="title"><b>Example 1.1. variable example</b></p><div class="example-contents"><pre class="programlisting">
modparam("statistics", "variable", "register_counter")
modparam("statistics", "variable", "active_calls/no_reset")
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249604"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249609"></a>1.4.1. 
		<code class="function">update_stat(variable,value)</code>
		</h3></div></div></div><p>
		Updates the value of the statistic variable with the new value.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>variable</em></span> - variable to be updated
			(it can be a string or a pseudovariable);
			</p></li><li><p><span class="emphasis"><em>value</em></span> - value to update with; it may be
			also negative.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, BRANCH_ROUTE, 
		FAILURE_ROUTE and ONREPLY_ROUTE.
		</p><div class="example"><a name="id248384"></a><p class="title"><b>Example 1.2. <code class="function">update_stat</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
update_stat("register_counter", "+1");
...
$var(a_calls) = "active_calls";
update_stat("$var(a_calls)", "-1");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248403"></a>1.4.2. 
		<code class="function">reset_stat(variable)</code>
		</h3></div></div></div><p>
		Resets to zero the value of the statistic variable.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>variable</em></span> - variable to be reset-ed
			(it can be a string or a pseudovariable).
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, BRANCH_ROUTE, 
		FAILURE_ROUTE and ONREPLY_ROUTE.
		</p><div class="example"><a name="id248437"></a><p class="title"><b>Example 1.3. <code class="function">reset_stat</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
reset_stat("register_counter");
...
$var(reg_counter) = "register_counter";
update_stat("$var(reg_counter)");
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293409"></a>1.5. Exported pseudo-variables</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293414"></a>1.5.1. <code class="varname">$stat</code></h3></div></div></div><p>
			Allows to get and reset core and modules exported statistics.
			The pseudo-variable receives as parameter the name of the
			statistic that it want to get or reset.
			</p><div class="example"><a name="id293426"></a><p class="title"><b>Example 1.4. <code class="varname">$stat</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
xlog("SHM used size = $stat(used_size) \n");
...
$stat(err_requests) = 0;
...
			</pre></div></div><br class="example-break"></div></div></div></div></body></html>
